Submit a batch of commands and wait for the transaction trees response
POST
JSON Ledger API
Submit a batch of commands and wait for the transaction trees response
OpenAPISince 3.4Changed 3.5Remove as of 3.5.0
Protocol Details
Inputs
Request body
application/json
object[]
required
OpenAPI type:
Command[].Individual elements of this atomic command. Must be non-empty. Required: must be non-emptystring
required
Uniquely identifies the command. The triple (user_id, act_as, command_id) constitutes the change ID for the intended ledger change, where act_as is interpreted as a set of party names. The change ID can be used for matching the intended ledger changes with all their completions. Must be a valid LedgerString (as described in
value.proto). Requiredstring[]
required
Set of parties on whose behalf the command should be executed. If ledger API authorization is enabled, then the authorization metadata must authorize the sender of the request to act on behalf of each of the given parties. Each element must be a valid PartyIdString (as described in
value.proto). Required: must be non-emptystring
Uniquely identifies the participant user that issued the command. Must be a valid UserIdString (as described in
value.proto). Required unless authentication is used with a user token. In that case, the token’s user-id will be used for the request’s user_id. Optionalstring[]
Set of parties on whose behalf (in addition to all parties listed in
act_as) contracts can be retrieved. This affects Daml operations such as fetch, fetchByKey, lookupByKey, exercise, and exerciseByKey. Note: A participant node of a Daml network can host multiple parties. Each contract present on the participant node is only visible to a subset of these parties. A command can only use contracts that are visible to at least one of the parties in act_as or read_as. This visibility check is independent from the Daml authorization rules for fetch operations. If ledger API authorization is enabled, then the authorization metadata must authorize the sender of the request to read contract data on behalf of each of the given parties. Optional: can be emptystring
Identifier of the on-ledger workflow that this command is a part of. Must be a valid LedgerString (as described in
value.proto). Optionalobject
OpenAPI type:
DeduplicationPeriod.Specifies the deduplication period for the change ID. If omitted, the participant will assume the configured maximum deduplication time. Optionalstring
Lower bound for the ledger time assigned to the resulting transaction. Note: The ledger time of a transaction is assigned as part of command interpretation. Use this property if you expect that command interpretation will take a considerate amount of time, such that by the time the resulting transaction is sequenced, its assigned ledger time is not valid anymore. Must not be set at the same time as min_ledger_time_rel. Optional
object
OpenAPI type:
Duration.string
A unique identifier to distinguish completions for different submissions with the same change ID. Typically a random UUID. Applications are expected to use a different UUID for each retry of a submission with the same change ID. Must be a valid LedgerString (as described in
value.proto). If omitted, the participant or the committer may set a value of their choice. Optionalobject[]
OpenAPI type:
DisclosedContract[].Additional contracts used to resolve contract & contract key lookups. Optional: can be emptystring
Must be a valid synchronizer id Optional
string[]
The package-id selection preference of the client for resolving package names and interface instances in command submission and interpretation Optional: can be empty
object[]
OpenAPI type:
PrefetchContractKey[].Fetches the contract keys into the caches to speed up the command processing. Each entry specifies a key and a limit on how many contracts to prefetch for that key. The limit does not count disclosed contracts, and should reflect the number of additional contracts expected to be resolved during interpretation of the commands. If a key appears multiple times, the last entry’s limit wins. Optional: can be emptynumber
OpenAPI type:
integer (int32).The maximum number of passes for the Topology-Aware Package Selection (TAPS). Higher values can increase the chance of successful package selection for routing of interpreted transactions. If unset, this defaults to the value defined in the participant configuration. The provided value must not exceed the limit specified in the participant configuration. OptionalOutputs
200
application/json
JsTransactionTree
Provided for backwards compatibility, it will be removed in the Canton version 3.5.0. Complete view of an on-ledger transaction.
400
text/plain
string
required
default
application/json
string
required
string
required
string
string
Map_String
required
Tuple2_String_String[]
integer (int32)
required
integer (int32)
string
boolean
History
Remove as of
3.5.0Changed
3.5The POST /v2/commands/submit-and-wait-for-transaction-tree operation changed in this snapshot.
Deprecated
3.4Introduced
3.4